---
# roles/gitlab_runner/tasks/main.yml

## Repository management

- name: "Manage gitlab_runner Repository"
  ansible.builtin.template:
    src: "runner_gitlab-runner.repo"
    dest: "/etc/yum.repos.d/runner_gitlab-runner.repo"
    owner: "root"
    group: "root"
    mode: 0644
  become: true
  tags:
    - "gitlab_runner"
    - "repository"

## Package management

- name: "Manage gitlab_runner Packages"
  ansible.builtin.package:
    name: "{{ gitlab_runner_package_names }}"
    state: "{{ gitlab_runner_package_state }}"
  become: true
  tags:
    - "gitlab_runner"
    - "package"

## Configuration management

- name: "Manage gitlab_runner runners Configuration"
  ansible.builtin.include_tasks:
    file: "configure_runner.yml"
  loop: "{{ gitlab_runner_configuration.runners }}"
  loop_control:
    loop_var: "runner"
  when:
    - "gitlab_runner_configuration.runners | length > 0"
    - "gitlab_runner_registration_enabled | bool"
    - "gitlab_runner_package_state != 'absent'"
  tags:
    - "gitlab_runner"
    - "configuration"

- name: "Manage gitlab_runner Configuration"
  ansible.builtin.lineinfile:
    path: "/etc/gitlab-runner/config.toml"
    regexp: "^concurrent = .*"
    line: "concurrent = {{ gitlab_runner_configuration.concurrent }}"
    owner: "root"
    group: "root"
    mode: 0600
  become: true
  notify:
    - "Restart gitlab_runner Service"
  when:
    - "gitlab_runner_package_state != 'absent'"
  tags:
    - "gitlab_runner"
    - "configuration"

## Service management

- name: "Manage gitlab_runner Service"
  ansible.builtin.service:
    name: "{{ gitlab_runner_service_name }}"
    state: "{{ gitlab_runner_service_state }}"
    enabled: "{{ gitlab_runner_service_enabled }}"
  become: true
  when:
    - "gitlab_runner_package_state != 'absent'"
  tags:
    - "gitlab_runner"
    - "service"
...
